// Code generated by kok; DO NOT EDIT.
// github.com/RussellLuo/kok

package profilesvcgrpc

import (
	"context"

	"github.com/RussellLuo/kok/pkg/httpoption"
	"github.com/RussellLuo/validating/v2"
	"github.com/go-kit/kit/endpoint"
)

type DeleteAddressRequest struct {
	Id        string `json:"id"`
	AddressID string `json:"address_id"`
}

// ValidateDeleteAddressRequest creates a validator for DeleteAddressRequest.
func ValidateDeleteAddressRequest(newSchema func(*DeleteAddressRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*DeleteAddressRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type DeleteAddressResponse struct {
	Err error `json:"-"`
}

func (r *DeleteAddressResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *DeleteAddressResponse) Failed() error { return r.Err }

// MakeEndpointOfDeleteAddress creates the endpoint for s.DeleteAddress.
func MakeEndpointOfDeleteAddress(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*DeleteAddressRequest)
		err := s.DeleteAddress(
			ctx,
			req.Id,
			req.AddressID,
		)
		return &DeleteAddressResponse{
			Err: err,
		}, nil
	}
}

type DeleteProfileRequest struct {
	Id string `json:"id"`
}

// ValidateDeleteProfileRequest creates a validator for DeleteProfileRequest.
func ValidateDeleteProfileRequest(newSchema func(*DeleteProfileRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*DeleteProfileRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type DeleteProfileResponse struct {
	Err error `json:"-"`
}

func (r *DeleteProfileResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *DeleteProfileResponse) Failed() error { return r.Err }

// MakeEndpointOfDeleteProfile creates the endpoint for s.DeleteProfile.
func MakeEndpointOfDeleteProfile(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*DeleteProfileRequest)
		err := s.DeleteProfile(
			ctx,
			req.Id,
		)
		return &DeleteProfileResponse{
			Err: err,
		}, nil
	}
}

type GetAddressRequest struct {
	Id        string `json:"id"`
	AddressID string `json:"address_id"`
}

// ValidateGetAddressRequest creates a validator for GetAddressRequest.
func ValidateGetAddressRequest(newSchema func(*GetAddressRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*GetAddressRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type GetAddressResponse struct {
	Address Address `json:"address"`
	Err     error   `json:"-"`
}

func (r *GetAddressResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *GetAddressResponse) Failed() error { return r.Err }

// MakeEndpointOfGetAddress creates the endpoint for s.GetAddress.
func MakeEndpointOfGetAddress(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*GetAddressRequest)
		address, err := s.GetAddress(
			ctx,
			req.Id,
			req.AddressID,
		)
		return &GetAddressResponse{
			Address: address,
			Err:     err,
		}, nil
	}
}

type GetAddressesRequest struct {
	Id string `json:"id"`
}

// ValidateGetAddressesRequest creates a validator for GetAddressesRequest.
func ValidateGetAddressesRequest(newSchema func(*GetAddressesRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*GetAddressesRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type GetAddressesResponse struct {
	Addresses []Address `json:"addresses"`
	Err       error     `json:"-"`
}

func (r *GetAddressesResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *GetAddressesResponse) Failed() error { return r.Err }

// MakeEndpointOfGetAddresses creates the endpoint for s.GetAddresses.
func MakeEndpointOfGetAddresses(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*GetAddressesRequest)
		addresses, err := s.GetAddresses(
			ctx,
			req.Id,
		)
		return &GetAddressesResponse{
			Addresses: addresses,
			Err:       err,
		}, nil
	}
}

type GetProfileRequest struct {
	Id string `json:"id"`
}

// ValidateGetProfileRequest creates a validator for GetProfileRequest.
func ValidateGetProfileRequest(newSchema func(*GetProfileRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*GetProfileRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type GetProfileResponse struct {
	Profile Profile `json:"profile"`
	Err     error   `json:"-"`
}

func (r *GetProfileResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *GetProfileResponse) Failed() error { return r.Err }

// MakeEndpointOfGetProfile creates the endpoint for s.GetProfile.
func MakeEndpointOfGetProfile(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*GetProfileRequest)
		profile, err := s.GetProfile(
			ctx,
			req.Id,
		)
		return &GetProfileResponse{
			Profile: profile,
			Err:     err,
		}, nil
	}
}

type PatchProfileRequest struct {
	Id      string  `json:"id"`
	Profile Profile `json:"profile"`
}

// ValidatePatchProfileRequest creates a validator for PatchProfileRequest.
func ValidatePatchProfileRequest(newSchema func(*PatchProfileRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*PatchProfileRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type PatchProfileResponse struct {
	Err error `json:"-"`
}

func (r *PatchProfileResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *PatchProfileResponse) Failed() error { return r.Err }

// MakeEndpointOfPatchProfile creates the endpoint for s.PatchProfile.
func MakeEndpointOfPatchProfile(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*PatchProfileRequest)
		err := s.PatchProfile(
			ctx,
			req.Id,
			req.Profile,
		)
		return &PatchProfileResponse{
			Err: err,
		}, nil
	}
}

type PostAddressRequest struct {
	Id      string  `json:"id"`
	Address Address `json:"address"`
}

// ValidatePostAddressRequest creates a validator for PostAddressRequest.
func ValidatePostAddressRequest(newSchema func(*PostAddressRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*PostAddressRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type PostAddressResponse struct {
	Err error `json:"-"`
}

func (r *PostAddressResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *PostAddressResponse) Failed() error { return r.Err }

// MakeEndpointOfPostAddress creates the endpoint for s.PostAddress.
func MakeEndpointOfPostAddress(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*PostAddressRequest)
		err := s.PostAddress(
			ctx,
			req.Id,
			req.Address,
		)
		return &PostAddressResponse{
			Err: err,
		}, nil
	}
}

type PostProfileRequest struct {
	Profile Profile `json:"profile"`
}

// ValidatePostProfileRequest creates a validator for PostProfileRequest.
func ValidatePostProfileRequest(newSchema func(*PostProfileRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*PostProfileRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type PostProfileResponse struct {
	Err error `json:"-"`
}

func (r *PostProfileResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *PostProfileResponse) Failed() error { return r.Err }

// MakeEndpointOfPostProfile creates the endpoint for s.PostProfile.
func MakeEndpointOfPostProfile(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*PostProfileRequest)
		err := s.PostProfile(
			ctx,
			req.Profile,
		)
		return &PostProfileResponse{
			Err: err,
		}, nil
	}
}

type PutProfileRequest struct {
	Id      string  `json:"id"`
	Profile Profile `json:"profile"`
}

// ValidatePutProfileRequest creates a validator for PutProfileRequest.
func ValidatePutProfileRequest(newSchema func(*PutProfileRequest) validating.Schema) httpoption.Validator {
	return httpoption.FuncValidator(func(value interface{}) error {
		req := value.(*PutProfileRequest)
		return httpoption.Validate(newSchema(req))
	})
}

type PutProfileResponse struct {
	Err error `json:"-"`
}

func (r *PutProfileResponse) Body() interface{} { return r }

// Failed implements endpoint.Failer.
func (r *PutProfileResponse) Failed() error { return r.Err }

// MakeEndpointOfPutProfile creates the endpoint for s.PutProfile.
func MakeEndpointOfPutProfile(s Service) endpoint.Endpoint {
	return func(ctx context.Context, request interface{}) (interface{}, error) {
		req := request.(*PutProfileRequest)
		err := s.PutProfile(
			ctx,
			req.Id,
			req.Profile,
		)
		return &PutProfileResponse{
			Err: err,
		}, nil
	}
}
